using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Collections;

namespace PocketRassegnaRAI
{
    public static class GlobalVars
    {
        //impostazioni del programma
        private static CSettings _objSettings;
        public static CSettings Settings
        {
            get { return _objSettings; }
            set { _objSettings = value; }
        }

        //Titolo da usare nei messagebox
        public static string ProgName
        {
            get { return "PocketRassegnaRAI"; }
        }

        //Titolo da usare quando cerca se ci sono versioni piu' aggiornate del software
        public static string ProgID
        {
            get { return "PocketRassegnaRAI"; }
        }

        //versione attuale del programma
        public static int ProgVersion
        {
            get { return 10000; }
        }

        //path del programma
        private static string _strProgPath;
        public static string ProgPath
        {
            get { return _strProgPath; }
            set { _strProgPath = value; }
        }

        //path del file delle impostazioni
        private static string _strSettingFilePath;
        public static string SettingFilePath
        {
            get { return _strSettingFilePath; }
            set { _strSettingFilePath = value; }
        }

        //file da scaricare a secondo delle scelte fatte nella Sezione e Sottosezione
        private static string[,] _strFilesToDownload;
        public static string[,] FilesToDownload
        {
            get
            {
                if (null == _strFilesToDownload) loadFilesToDownloadList();
                return _strFilesToDownload;
            }
        }

        //dalla lista con le impostazioni crea quella dei file da scaricare, piu' facile da consultare
        public static void loadFilesToDownloadList()
        {
            int intIndex1;
            int intIndex2;
            int intPos1;
            int intPos2;

            intIndex1 = Settings.Level1Items.Count;
            intIndex2 = Settings.Level2Items.Count;

            _strFilesToDownload = new String[intIndex1, intIndex2];

            foreach (string strItem in Settings.FilesToDownload)
            {
                intPos1 = strItem.IndexOf(Settings.SeparatorChar);
                intPos2 = strItem.IndexOf(Settings.SeparatorChar, intPos1 + 1);
                intIndex1 = Convert.ToInt32(strItem.Substring(0, intPos1).Trim());
                intIndex2 = Convert.ToInt32(strItem.Substring(intPos1 + 1, intPos2 - intPos1 - 1).Trim());
                _strFilesToDownload[intIndex1, intIndex2] = strItem.Substring(intPos2 + 1).Trim();
            }
        }

        //puntatori ai form
        private static Hashtable _colForms = new Hashtable();
        public static Hashtable Forms
        {
            get { return _colForms; }
            set { _colForms = value; }
        }
	
        //private static frmMain _frmMain;
        //public static frmMain frmMain
        //{
        //    get { return _frmMain; }
        //    set { _frmMain = value; }
        //}
        //private static frmSettings _frmSettings;
        //public static frmSettings frmSettings
        //{
        //    get { return _frmSettings; }
        //    set { _frmSettings = value; }
        //}
        //private static frmAbout _frmAbount;
        //public static frmAbout frmAbout
        //{
        //    get { return _frmAbount; }
        //    set { _frmAbount = value; }
        //}
    }
}
